<?php if (!defined('PmWiki')) exit();
/**
 * get_set_qnotes.php
 * @author V.Krishn (vkrishn@insteps.net), Copyright 2010-2019
 * @note This file is part of Cookbook recipe "QNotes" for PmWiki;
 * You can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the  Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version. @see pmwiki.php for full details.
 * @package qnotes
 */

// **********************************************************
// Some fuctions for qnotes nodes
// **********************************************************

  $QNotes['qns_num'] = 300;
  $QNotes['qnrb'] = '\\(:div300\\s+?title=\'\\/\'.*?:\\)(.*?)\\(:div300end:\\)';
  $QNotes['qnre'] = '(\\(:div300end:\\).*?\\[\\[\\#qnotesend\\]\\])';
  $QNotes['qns'] = '(\\(:div{$n1}\\s+?title=\'$cfmt\'\\s+?:\\))';
  $QNotes['qne'] = '(\\(:div{$n2}end:\\))';
  $QNotes['qnb'] = $QNotes['qns'].'(.*?)'.$QNotes['qne'];
  $QNotes['qncs'] = '(\\(:div{$n3}\\s+?title=\'$cfmt\\/.*?\'\\s.*?:\\))';
  $QNotes['qncb'] = '\\(:div{$n1}\\s+?title=\'$cfmt\'\\s*(.*?):\\)(.*?)\\(:div{$n1}end:\\)';
  $QNotes['qnwcb'] = $QNotes['qns'].'(.*?)'.$QNotes['qncs'];
  $QNotes['qnts'] = '(!!!.*?)(\\(:div490\\s+?class=.*?:\\))';
  $QNotes['qnte'] = '(\\(:div490end:\\))';
  $QNotes['qntb'] = $QNotes['qnts'].'(.*?)'.$QNotes['qnte'];
  $QNotes['qncmb'] = '\\(:div501\\sclass=\'comment\'.*?:\\)\\n(%title%.*?%%)(.*?)\\(:div501end:\\)';
  $QNotes['qnctb'] = '(\\(:div510\\s+?id=\'categories\'.*?:\\))(.*?)(\\(:div510end:\\))';
  $QNotes['qnctb2'] = '\\(:div510\\s+?id=\'categories\'.*?:\\)(.*?)\\(:div510end:\\)';
  $QNotes['qnds'] = '(\\(:div{$n3}\\s.*?:\\))';
  $QNotes['qnd'] = '(\\(:div.*?:\\))'; //(\\(:div{$n4}:\\))
  $QNotes['qntb_s'] = '(:div490 class=\'text\':)$qntext$nl(:div490end:)';
  $QNotes['qntb_s2'] = '$qntitle$nl'.$QNotes['qntb_s'];
  $QNotes['qncms_s'] = '(:div501 class=\'comment\' title=\'$title\':)';
  $QNotes['qncme_s'] = "(:div501end:)";
  $QNotes['qncmb_s'] = '$nl'.$QNotes['qncms_s'].'$nl$comment$nl'.$QNotes['qncme_s'].'$nl';
  $QNotes['qns_s'] = '(:div{$num} title=\'$cat\' $opts:)';
  $QNotes['qne_s'] = '(:div{$num}end:)';


  function qnotes_node_category_fmt($qn='/default', $esc=true) {

    $nc = '/'.$qn;
    $nc = preg_replace('/\\s+?/', '_', $nc);
    $nc = preg_replace('/[^\\w\\x80-\\xfe\\-\\/\\.]/', '', $nc);
    $nc = preg_replace('#/+#', '/', $nc);
    global $Charset;
    if(isset($Charset) && $Charset == 'UTF-8') {
      //$nc = utf8fold($nc);
      $nc = mb_convert_case($nc, MB_CASE_LOWER, "UTF-8");
      $nc = rtrim(trim($nc), '/');
    } else {
      $nc = strtolower(rtrim(trim($nc), '/'));
    }
    if($nc == '/' || $nc == '') { $nc = '/default'; }
    $nc = qnotes_node_category_esc($nc, $esc);

    return $nc;

  }

  function qnotes_node_category_esc($qn='/default', $esc=true) {

    if($qn == '/' || $qn == '') { $qn = '/default'; }
    $arr = array('/' => '\\/', '-' => '\\-', '.' => '\\.');
    if($esc) $qn = strtr($qn, $arr);
    return $qn;

  }

  function qnotes_node_get_parentcategory($qn, $esc=true) {

    $nc = qnotes_node_category_fmt($qn, $esc);
    $nc =  preg_replace('#/[^/]*$#', '', $nc);
    if(! $nc || $nc == '')  { $nc = '/'; }
    return $nc;

  }

  function qnotes_node_title_fmt($qntitle='#') {

    $qntitle = preg_replace('/\\//', '_', $qntitle); //for urls as title
    $qntitle = preg_replace('/[^\\w\\x80-\\xfe\\-\\.\\(\\)\\?\\s]/i', '', $qntitle);
    $qntitle = trim($qntitle);

    if($qntitle == '') { $qntitle = '#'; }
    return $qntitle;

  }

  function qnotes_qnd_preserve($m) {
    $num = $m[2]+300; return '(:div' . $num;
  }
  function qnotes_node_text_fmt($qntext='') {

    global $QNotes;
    $s = array('<', '>');
    $r = array('&lt;', '&gt;');
    if($QNotes['isAllowDirectivesInText'] == 1) {
      $qndfmt = '(\\(:div)([345]\\d\\d)(\\s*?)';
      $qntext = preg_replace_callback("/$qndfmt/i", 'qnotes_qnd_preserve', $qntext);
    } else {
      $s1 = array('(:', ':)'); $s = array_merge($s, $s1);
      $r1 = array("(", ')'); $r = array_merge($r, $r1);
    }
    //$qntext = str_replace($s, $r, $qntext); //notneeded ? make a config.php opt/variable

    $qntext = trim($qntext);
    return $qntext;

  }

  function qnotes_link_args($text='') {

    $qnlb = "\\(:qnotes\\slink\\s(.*?):\\)";
    preg_match("/$qnlb/si", $text, $m);
    if($m[1]) {
      $args = ParseArgs($m[1]);
      $a['qnp'] = MakePageName($pagename, $args[''][1]);
      $a['qn'] = qnotes_node_category_fmt($args['category'], false);
      return $a;
    }
    return false;

  }
  function qnotes_get_comment_node($text='', $textOnly=1) {

    global $QNotes;
    $qncmb = &$QNotes['qncmb'];
    preg_match("/$qncmb/si", $text, $m);
    if($m[0]) {
      if( ! $textOnly) return $m[0];
      return trim($m[2]);
    }
    return false;

  }

  function qnotes_set_link_node(&$p) {

    if( ! is_array($p)) return false;

    global $QNotes;
    //(:qnotes ID link qnotePage category='' :)
    $comment = trim(qnotes_node_title_fmt($p['qnotesComment']),'#');
    if(trim($comment)) {
      $comment =  "%title%comment:%% \n" . $comment;
      $title = 'Linkto:: Page:'.$p['qnotesLinkToPgName'] . ' Category:'.$p['qnotesLinkTo'];
      $t = array('$comment' => $comment, '$title' => $title, '$nl' => "\n");
      $comment = strtr($QNotes['qncmb_s'], $t);
    }
    $pn = MakePageName($pagename, $p['qnotesLinkToPgName']);
    $c = qnotes_node_category_fmt($p['qnotesLinkTo'], false);
    $t = "(:qnotes link link '" . $pn . "' category='".$c."' :)" . $comment;

    $p['qnotesText'] = &$t;
    return $p;

  }

  function qnotes_get_categories($qnp, &$qnpage=array()) {

    global $QNotes;

    $pagefmt = $qnpage['text'];
    if ( ! $pagefmt || trim($pagefmt) == '') {
      $pagefmt = qnotes_get_page_content($qnp);
    }
    if ( ! $pagefmt || trim($pagefmt) == '' || $qnp == '') return false;

    $qnctb2 = &$QNotes['qnctb2'];
    preg_match("/$qnctb2/si", $pagefmt, $m);

    if($m[0]) {
      $QNotes[$qnp]['categories'] = $m;
      return $m;
    }
    return false;

  }

  function qnotes_get_categories_array($qnp, &$qnpage=array()) {

    global $QNotes;
    $temp = qnotes_get_categories($qnp, $qnpage);

    if(trim($temp[1]) == '') $temp[1] = '/'; //default root node
    return explode("\n", trim($temp[1]));

  }

  function qnotes_iscategory($mc, &$cb) {
    if( preg_match("/^$mc\$/im", $cb[1], $m)
        || preg_match("/^$mc#.*?\$/im", $cb[1], $m) )
      { return $m; } else { return false; }
  }

  function qnotes_category_haschild($qn, &$cb) {
    $mc = qnotes_node_category_fmt($qn, true);
    if( preg_match("/^$mc\/.*?\$/im", $cb[1], $m) ) {
      return $c = (is_array($m) && count($m) > 0) ? true : false; }
  }

  function qnotes_set_categories_array($qnp, $qn, &$qnpage=array(), $title='', $action='update') {

    global $QNotes;
    $cb = qnotes_get_categories($qnp, $qnpage);
    $qn = qnotes_node_category_fmt($qn, false);
    $mc = qnotes_node_category_fmt($qn, true);
    $b = array(); $m = '';
    $cb[1] = str_replace('#link', '#1', $cb[1]); //to deprecate in 2.2.3

    // properties
    $c1 = $QNotes['nprop']['islink'] === 1 ? '1' : '0';
    $c2 = 0; # 0|1|2|3 - no|isLocked|childLock|self+childLock //@todo
    $c3 = 0; # //@todo --- reserved for other recipes ---
    $c4 = 0; # 0|1|2|3 - no|isHidden|isModerated|isSuspended //@todo
    $c5 = $QNotes['now'][0]; #created on timestamp
    $c6 = $QNotes['now'][0]; #updated on timestamp
    $c7 = 0; # authType::read|edit::0|1 //@todo
    $c8 = 0; # //@todo
    $c9 = ltrim($title, '!'); #qnote title

    $m = qnotes_iscategory($mc, $cb);

    if( is_array($m) ) {
      $t = explode('#', $m[0]);
      $c5 = isset($t[5]) ? $t[5] : $c5;
      $c3 = isset($t[3]) ? $t[3] : $c3;
      $ct = $qn.'#'.$c1.'#'.$c2.'#'.$c3.'#'.$c4.'#'.$c5.'#'.$c6.'#'.$c7.'#'.$c8.'#'.$c9;
      $mc = preg_quote($m[0], '/');

      if('delete' == $action) {
        if( ! qnotes_category_haschild($qn, $cb) ) {
          $cb[1] = preg_replace("/^$mc\$/im", '', $cb[1]); }
      } else {
        $cb[1] = preg_replace("/^$mc\$/im", $ct, $cb[1]);
      }

    } else { //is new node
      while ( ! qnotes_iscategory($mc, $cb) )
      {
        $b[] = $qn.'#'.$c1.'#'.$c2.'#'.$c3.'#'.$c4.'#'.$c5.'#'.$c6.'#'.$c7.'#'.$c8.'#'.$c9;
        $c1 = '0';
        $c9 = '';
        $qn = qnotes_node_get_parentcategory($qn, false);
        if($qn == '/') { break; }
        $mc = qnotes_node_category_esc($qn, true);
      }
    }

    if(trim($cb[1]) == '') $cb[1] = '/'; //default root node
    $a = explode("\n", trim($cb[1]));
    if(is_array($b) && count($b) > 0) $a = array_merge($a, $b);

    $a = qnotes_list_sort($a);
    return implode("\n", $a);

  }

  function qnotes_node_get_root($qnp, &$qnpage=array()) {

    global $QNotes;

    $pagefmt = &$qnpage['text'];
    if ( ! $pagefmt || trim($pagefmt) == '') {
      $pagefmt = qnotes_get_page_content($qnp);
    }
    if ( ! $pagefmt || trim($pagefmt) == '' || $qnp == '') return;

    $qnrb = &$QNotes['qnrb'];
    preg_match("/$qnrb/si", $pagefmt, $m);

    if($m[0]) {
      //$QNotes[$qnp]['/'] = $m;
      return $m;
    }
    return false;

  }

  function qnotes_node_get_bycategory($qnp, $qn, &$qnpage=array()) {

    global $QNotes;

    $pagefmt = &$qnpage['text'];
    if ( ! $pagefmt || trim($pagefmt) == '') {
      $pagefmt = qnotes_get_page_content($qnp);
    }
    if ( ! $pagefmt || trim($pagefmt) == '' || $qn == '' || $qnp == '') return;

    $num = substr_count($qn, '/')+$QNotes['qns_num'];
    $cfmt = qnotes_node_category_fmt($qn);
    $t = array('$cfmt' => $cfmt, '{$n1}' => $num, '$nl' => "\n");
    $qncb = strtr($QNotes['qncb'], $t);
    preg_match("/$qncb/si", $pagefmt, $m);

    if($m[0]) {
      $QNotes[$qnp][$cfmt] = $m;
      return $m;
    }
    return false;

  }

  function qnotes_node_haschild($qnp, $qn, &$qnpage=array()) {

    global $QNotes;

    $pagefmt = &$qnpage['text'];
    if ( ! $pagefmt || trim($pagefmt) == '') {
      $pagefmt = qnotes_get_page_content($qnp);
    }
    if ( ! $pagefmt || trim($pagefmt) == '' || $qn == '' || $qnp == '') return false;

    $cfmt = qnotes_node_category_fmt($qn);
    $n3 = substr_count($cfmt, '/')+1+$QNotes['qns_num'];
    $t = array('$cfmt' => $cfmt, '{$n3}' => $n3, '$nl' => "\n");
    $qncs = strtr($QNotes['qncs'], $t);

    preg_match("/$qncs/i", $pagefmt, $m);
    if(trim($m[0]) !== '') return true;
    return false;

  }

  function qnotes_nodetext_get_bycategory($qnp, $qn, &$qnpage=array(), $txtonly=0) {

    global $QNotes;

    $pagefmt = &$qnpage['text'];
    if ( ! $pagefmt || trim($pagefmt) == '') {
      $pagefmt = qnotes_get_page_content($qnp);
    }
    if ( ! $pagefmt || trim($pagefmt) == '' || $qn == '' || $qnp == '') return false;

    $cfmt = qnotes_node_category_fmt($qn);
    $n1 = substr_count($cfmt, '/')+$QNotes['qns_num']; $n3 = $n1+1;
    if($cfmt == '/') { $n1 = $QNotes['qns_num']; }

    $cn = qnotes_node_get_bycategory($qnp, $qn, $qnpage);
    $nt['text'] = &$cn[0];
    $hasChild = qnotes_node_haschild($qnp, $qn, $nt);
    if( ! $hasChild) $n2 = $n1;
    $t = array('$cfmt' => $cfmt, '{$n1}' => $n1,
               '{$n2}' => $n2, '{$n3}' => $n3, '$nl' => "\n");

    $qnb = strtr($QNotes['qnb'], $t);
    $qnwcb = strtr($QNotes['qnwcb'], $t);
    $qncs = strtr($QNotes['qncs'], $t);
    $qntb = strtr($QNotes['qntb'], $t);

    $qnotesPat1 = ($hasChild) ? $qnwcb : $qnb;
    preg_match("/$qnotesPat1/si", $pagefmt, $m);
    if( ! $txtonly) {
      if(trim($m[2])) { return $m[2]; } else { return false; }
    }

    preg_match("/$qntb/si", $m[2], $m2);
    if($m2[1].trim($m2[3])) { return $m2[1].trim($m2[3]);  }

    return false;

  }

  function qnotes_node_get_parentbycategory($qnp, $qn, &$qnpage=array()) {
    $qn = qnotes_node_get_parentcategory($qn);
    return qnotes_node_get_bycategory($qnp, $qn, $qnpage);
  }

  function qnotes_node_resolve_bycategory($qnp, $qn, &$qnpage=array()) {
    global $QNotes;
    $resData['cnt'] = 0;
    $resData['cat_toupdate'] = qnotes_node_category_fmt($qn, false);
    while ( ! qnotes_node_get_bycategory($qnp, $qn, $qnpage)) {
      $resData['cnt']++;
      $qn = qnotes_node_get_parentcategory($qn, false);
      $resData['cat_toupdate'] = $qn;
      if($qn == '/') {
        qnotes_node_get_root($qnp, $qnpage);
        break;
      }
    }
    return $resData;
  }

  function qnotes_node_makenodes_bycategory($qnp, $qn, $count=0) {

    global $QNotes;
    $temp = array();

    while ($count >= 1) {
      $cat = qnotes_node_category_fmt($qn, false);
      $num = substr_count($cat, '/')+$QNotes['qns_num'];
      if($num == $QNotes['qns_num']) $num = 299; //debug

      $t = array('$cat' => $cat, '{$num}' => $num, '$opts' => '', '$nl' => "\n");
      $a[] = strtr($QNotes['qns_s'], $t);
      $b[] = strtr($QNotes['qne_s'], $t);

      $qn = qnotes_node_get_parentcategory($qn);
      $count--;

    }
    if(count($a) > 0) {
      return "\n".implode("\n",array_reverse($a))."\n#"."\n".implode("\n",$b);
    }
    return false;

  }

# @TODO
  function qnotes_node_set_bycategory(&$updatedQNote, $action='update') {

    global $QNotes, $EnablePost, $ChangeSummary, $Now, $IsPagePosted,
           $ROEPatterns, $ROSPatterns;
    static $d = 0;
    $isNewNode = 0;

    $qnpagename = &$updatedQNote['qnotesPage']; //@TODO
    if($QNotes['qnotesIsAuthEdit']) {
      $page = RetrieveAuthPage($qnpagename, 'edit', 1);
      } else { $page = RetrieveAuthPage($qnpagename, 'read', 0); }
    if ( ! $page) return;
    //PCache($qnotesPage, $page);
    $pagefmt = @$page['text'];

    //sanitize if not
    $qncategory = &$updatedQNote['qnotesCategory'];
    $qntitle = &$updatedQNote['qnotesTitle'];
    $qntext = &$updatedQNote['qnotesText'];
    $qntitle = trim("!!!".$qntitle);

    if($qntext) $qntext = "\n".stripmagic($qntext);
    $KeepToken = "\035\035";

    $t = array('$qntext' => $KeepToken, '$qntitle' => $qntitle, '$nl' => "\n");
    $qnTxtFmt = strtr($QNotes['qntb_s2'], $t);

    $cn = qnotes_node_get_bycategory($qnpagename, $qncategory, $page);
    $nt['text'] = &$cn[0];

    $resData =  qnotes_node_resolve_bycategory($qnpagename, $qncategory, $nt);
    if($resData['cnt'] && $resData['cnt'] > 0) {
      $isNewNode = 1;
      $newNodes = qnotes_node_makenodes_bycategory($qnpagename, $qncategory, $resData['cnt']);
    }

    if($newNodes) { $rep1 = trim(str_replace('#', $qnTxtFmt, $newNodes)); }
    $tnum = substr_count($resData['cat_toupdate'], '/')+$QNotes['qns_num'];
    $cfmt = qnotes_node_category_fmt($resData['cat_toupdate']);

    if($isNewNode) { $n1 = $tnum; $n2 = $tnum; $n3 = $tnum+1;}
    if($resData['cat_toupdate'] == '/') { $n1 = $QNotes['qns_num']; }
    if($resData['cnt'] == 0) { $n1 = $tnum; $n2 = $tnum; $n3 = $tnum+1; }
    if($n1 == $QNotes['qns_num']) $n1 = ''; if($n2 == $QNotes['qns_num']) $n2 = '';//~todo
    $t = array('$cfmt' => $cfmt, '{$n1}' => $n1,
               '{$n2}' => $n2, '{$n3}' => $n3, '$nl' => "\n");

    $qnb = strtr($QNotes['qnb'], $t);
    $qnwcb = strtr($QNotes['qnwcb'], $t);
    $qncs  = strtr($QNotes['qncs'], $t);
    $qnctb = &$QNotes['qnctb'];
    $qnre  = &$QNotes['qnre'];

    if($isNewNode && trim($qntext) == 'delete') { return false; }

    //update/create node and nodetext
    // ----------------------------------------
    if($isNewNode && $resData['cat_toupdate'] !== '/') {
      $nt = trim(qnotes_nodetext_get_bycategory($qnpagename, $cfmt, $nt, 0));
      if($rep1) $rep1 = "\n".$rep1;
      if($QNotes['isNewPostAtEnd'] === 3 || $QNotes['isNewPostAtEnd'] === 4) {
        $newText = trim($rep1);
        $qnRepFmt = '$1$2'.$KeepToken."\n".'$3';
        $pagefmt = preg_replace("/$qnb/si", $qnRepFmt , $pagefmt, 1);
      } else {
        $newText = trim($nt.$rep1);
        if(preg_match("/$qncs/i", $pagefmt)) { $qnPatTxt = $qnwcb; } else { $qnPatTxt = $qnb; }
        $qnRepFmt = '$1'."\n".$KeepToken."\n".'$3';
        $pagefmt = preg_replace("/$qnPatTxt/si", $qnRepFmt , $pagefmt, 1);
      }
      $pagefmt = strtr($pagefmt, array($KeepToken => $newText));
    }
    if($resData['cat_toupdate'] == '/') {
      $pagefmt = preg_replace("/$qnre/si", trim($rep1)."\n".'$1', $pagefmt, 1);
    }
    if($resData['cnt'] == 0) {
      if( ! preg_match("/$qncs/i", $pagefmt)) { $qnPatTxt = $qnb; } else { $qnPatTxt = $qnwcb; }
      if('delete' == $action) {
        qnotes_node_delete_bycategory($pagefmt, $qnPatTxt, $tnum, $qncategory);
      } else {
        $pagefmt = preg_replace("/$qnPatTxt/si", '$1'."\n".$qnTxtFmt."\n".'$3', $pagefmt, 1);
      }
    }
    // insert nodetext
    // ----------------------------------------
    $t = array($KeepToken => $qntext);
    $pagefmt = strtr($pagefmt, $t);

    if(trim($pagefmt) == '') return false;
    //preg_match("/$qnotesPat2/si", $pagefmt, $m); //debug

    // update categories array/text
    // ----------------------------------------
    $c = qnotes_set_categories_array($qnpagename, $qncategory, $page, $qntitle, $action);
    $repfmt = '$1'."\n".$c."\n".'$3';
    $pagefmt = preg_replace("/$qnctb/si", $repfmt, $pagefmt, 1);
    if(trim($pagefmt) == '') return false;
    //print '<pre>'; print_r($pagefmt); print '</pre>'; exit;

    // Write on page
    // ----------------------------------------
    $new = $page; $new['text'] = $pagefmt;
    SDV($QNotes['isDiff'], 1);
    if($QNotes['isBatchUpdate'] == 1) { $d = 0; }
    if(is_array($QNotes['EditFunctions'])) { $fnlist = &$QNotes['EditFunctions']; }
    if($QNotes['isDiff'] == 0) { $page = ''; }
    if ($d < 1) {
      $d++; $IsPagePosted = UpdatePage($qnpagename, $page, $new, $fnlist);
    }
    unset($QNotes['EditFunctions'], $QNotes['isBatchUpdate'], $QNotes['isDiff']);

    return @$IsPagePosted;

  }

  function qnotes_node_delete_bycategory(&$pagefmt, &$qnPatTxt, $tnum, $qn) {
    $pagefmt = preg_replace("/$qnPatTxt/si", "$1\n$3", $pagefmt, 1);

    $mc = qnotes_node_category_fmt($qn, true);
    $a = '^(\(:div'.$tnum.'.*?'.$mc.'.*?:\))\n+?(\(:div'.$tnum.'end:\))'; //emptyNode
    $pagefmt = preg_replace("/$a/mi", "", $pagefmt, 1);

    $a = '(\(:div[345]\d{2}.*?:\))\n{2}+(\(:div[345]\d{2}.*?:\))';
    $pagefmt = preg_replace("/$a/si", "$1\n$2", $pagefmt, 1);

  }

  function qnotes_node_move_bycategory($qnp, $qn, $count=0) { //@TODO
  }


