<?php if (!defined('PmWiki')) exit();
/**
 * qnotes.edit.php
 * @author V.Krishn (vkrishn@insteps.net), Copyright 2010-2019
 * @note This file is part of Cookbook recipe "QNotes" for PmWiki;
 * You can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the  Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version. @see pmwiki.php for full details.
 * @package qnotes
 */

// **********************************************************
// Handle edit text request
// **********************************************************
  include_once('functions.php');
  include_once('get_set_qnotes.php');
  include_once('set_path_file.php');

  if(isset($Charset) && $Charset !== 'UTF-8') {
    qnotesSetAsyncRequestUrl();
  }
  $c = $_GET['qn']; $pn = $_GET['qnp'];

  $c = qnotes_node_category_fmt($c, false);
  $qnpage = qnotes_get_page($pn);
  $cn = qnotes_node_get_bycategory($qnp, $qn, $qnpage);
  $nt['text'] = &$cn[0];
  $a = qnotes_nodetext_get_bycategory($pn, $c, $nt, 1);

  $b = explode("\n", trim($a));
  $title = str_replace('!','',$b[0]);
  if(trim($title) == '') $title = '#';
  array_shift($b);

  $text = implode("\n", (array)$b);
  $text =  str_replace('$','&#036;', htmlspecialchars($text, ENT_NOQUOTES));

  $a = qnotes_link_args($text);
  if(is_array($a)) {
    $linkqnp = &$a['qnp']; $linkqn = &$a['qn'];
    $linkcomment = qnotes_get_comment_node($text);
  }

  if( ! $_GET['async'] || $_GET['async'] == '0') {
    $FmtPV['$qnoteCategory'] = "'$c'";
    $title = keep($title); $FmtPV['$qnoteTitle'] = "'$title'";
    $text = keep($text); $FmtPV['$qnoteText'] = "'$text'";
    if(is_array($a)) {
      $linkcomment = keep($linkcomment); $FmtPV['$qnoteLinkToComment'] = "'$linkcomment'";
      $FmtPV['$qnoteLinkToPn'] = "'$linkqnp'";
      $FmtPV['$qnoteLinkTo'] = "'$linkqn'";
    }
  }

  if($_GET['async'] == '1' && $_GET['qfmt'] == 'wiki') {
    qnotesSetAsyncDataHeader();

    if(isset($_GET['wrap']) && $_GET['wrap'] === 'precode') {
      $wrap_start = '<pre><code class="code.escaped">';
      $wrap_end = '</code></pre>';
    }

    if(is_array($a)) {
      $link = <<<EOF
          <div class='linkqnp'>$linkqnp</div>
          <div class='linkqn'>$linkqn</div>
          <div class='comment'>$linkcomment</div>
EOF;
    }
$t = <<<EOF
$wrap_start
<div id='qnroot'>
<div title='$c' class='text'>
    <div class='qncategory'>$c</div>
    <div class='qntitle'>$title</div>
    <div class='qntext'>$text</div>
    $link
</div>
</div>
$wrap_end
EOF;
    print_r($t);
    exit(0);
  }


