<?php if (!defined('PmWiki')) exit();
/**
 * qnotes.list.php
 * @author V.Krishn (vkrishn@insteps.net), Copyright 2010-2019
 * @note This file is part of Cookbook recipe "QNotes" for PmWiki;
 * You can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the  Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version. @see pmwiki.php for full details.
 * @package qnotes
 */

// **********************************************************
// Lists for nodes (list/menu/tree)
// **********************************************************
/*
  Directive
  (:qnotes ID list qnotePage listType='default|phplm|jscm'
           showrootnode=0 fetchMode='static|async'
           theme='' orient='' nodefmt=0|1|2|3|4|5|6|7|8
           type=2|3|4|5|6|7 start=/ wrap=none:)

*/

    $out = array();
    $qnotesOutFmt = '';
    global $ScriptUrl;

    if(@$args['showrootnode'] == '1' || @$args['showrootnode'] == true ) {
      $showrootnode = 1; } else { $showrootnode = 0; } //default

    $id = (isset($args['id'])) ? $args['id'] : $args[''][0];
    $class = (isset($args['class'])) ? $args['class'] : 'qnotesList';
    $qnDrawType = &$args[''][1];
    $qnPageName = &$args[''][2];
    $orient = &$args['orient'];
    $theme = &$args['theme'];
    $fetchmode = $QNotes['fetchMode'] = $args['fetchMode'];
    $type = (int)$args['type']; //phplm node type
    $wrap = $args['wrap'];
    $async = ''; if($fetchmode == 'async') { $async = ' async'; } 
    if(@$args['qnotelnk'] == '1' || @$args['qnotelnk'] == true ) {
      $qnotelnk = '%qnote'.$async.'%'; } else { $qnotelnk = ''; }

    $pageA = qnotes_get_page($qnPageName);
    $params = array();

    //SDV($QNotes['ListFilters'], 'qnotes_list_filter');
    $fn = function_exists($QNotes['ListFilters']) ?
          $QNotes['ListFilters'] : 'qnotes_list_filter';
    $params['start'] = (isset($args['start']) && $args['start'] !== '/') ? $args['start'] : '';
    $c = $fn($qnPageName, $pageA, $params);

    $qp = FmtPageName('$Name', $qnPageName); #@TODO
    $qnpagename = FmtPageName('$FullName', $qnPageName); #@TODO
    $pn = $QNotes['page']['CurrentGroup'].'.'.$QNotes['page']['CurrentName'];
    $c = qnotes_list_sort($c);

    $nodefmt = (int)$args['nodefmt'];
    $fmt[0] = '$v1';
    $fmt[1] = '$v1 $c9'; //category + title
    $fmt[2] = '$v1$c6'; //category + modifiedOn
    $fmt[3] = '$v1 [Title:$c9]$c6 '; //category + title + modifiedOn
    $fmt[4] = '$c9$c6 '; //title + modifiedOn
    $fmt[5] = '$c9'; //title
    $fmt[6] = '%c%$v1 %t%$c9 %d%$c6%%'; //category + title + modifiedOn
    $fmt[7] = '%t%$c9 %d%$c6%%'; //title + modifiedOn
    $fmt[8] = '%t%$c9%%'; //title
    if( ! $fmt[$nodefmt]) $nodefmt = 0;

    SDV($QNotes['ListDateFmt'], ' [%b %d, %Y, at %I:%M %p]');
    SDV($QNotes['ListDateFmt2'], ' [%b %d, %Y, at %I:%M %p]');

    if(
       strtolower($qnDrawType) === 'list' &&
       (strtolower(@$args['listType']) === '' || strtolower(@$args['listType']) === 'default')
      ) {

      //============== list output as wikilist #@TODO
      $GLOBALS['RedoMarkupLine']++;
      foreach($c as $v) {
        list($v, $c1, $c2, $c3, $c4, $c5, $c6, $c7, $c8, $c9) = explode('#', $v);
        $tfmt = empty($c9) ? $QNotes['ListDateFmt'] : $QNotes['ListDateFmt2'];
        $c6 = $c6 ? strftime($tfmt, $c6) : ''; # modifiedOn
        $num = substr_count($v, '/');
        $v1 = ucfirst(trim(str_replace('/', '', strrchr($v, '/'))));
        eval("\$v2 = \"$fmt[$nodefmt]\";");
        $edl = $ScriptUrl.'?n='.$pn.'&amp;qn='.$v.'&amp;qnp='.$qnpagename;
        if($v1 == '') {
          //$vf = '*[[#nolink|Root]]';
          if($showrootnode) $vf = '*[[#nolink|'.$qp.']]';
        } else {
          if($showrootnode) $num = $num+1;
          $num = str_repeat("*", $num);
          $qnotesOutFmt .=  "\n" . $num . $qnotelnk . '[[' . $edl . '|' . $v2 . ']]';
        }
      }
      //filter clean
      preg_match('/^\\*(\\**)[^\\*].*?$/im', $qnotesOutFmt, $m);
      $num = substr_count($m[1], '*');
      $qnotesOutFmt = preg_replace('/^(\\*){'.$num.'}/m', '', $qnotesOutFmt);

      $qnotesOutFmt =  ($wrap == 'none') ? "\n". $vf.$qnotesOutFmt . "\n"
           : "\n". "(:div10 id='$id' class='$class':)" .
             "\n".$vf.$qnotesOutFmt . "\n". '(:div10end:)';

      }

    if(
       strtolower($qnDrawType) === 'list' &&
       strtolower(@$args['listType']) === 'jscm'
      ) {

      //============== list output as wikilist for JsCm (menu) #@TODO
      $GLOBALS['RedoMarkupLine']++;
      foreach($c as $v) {
        list($v, $c1, $c2, $c3, $c4, $c5, $c6, $c7, $c8, $c9) = explode('#', $v);
        $tfmt = empty($c9) ? $QNotes['ListDateFmt'] : $QNotes['ListDateFmt2'];
        $c6 = $c6 ? strftime($tfmt, $c6) : ''; # modifiedOn
        $num = substr_count($v, '/');
        $v1 = ucfirst(trim(str_replace('/', '', strrchr($v, '/'))));
        eval("\$v2 = \"$fmt[$nodefmt]\";");
        $edl = $ScriptUrl.'?n='.$pn.'&amp;qn='.$v.'&amp;qnp='.$qnpagename;
        if($v1 == '') {
          if($showrootnode) $vf = '*~#~[[#nolink|'.$qp.']]';
        } else {
          if($showrootnode) $num = $num+1;
          $num = str_repeat("*", $num);
          $qnotesOutFmt .=  "\n" . $num . '~#~[[' . $edl . '|' . $v2 . ']]';
        }
      }
      //filter clean
      preg_match('/^\\*(\\**)[^\\*].*?$/im', $qnotesOutFmt, $m);
      $num = substr_count($m[1], '*');
      $qnotesOutFmt = preg_replace('/^(\\*){'.$num.'}/m', '', $qnotesOutFmt);

      $qnotesOutFmt =  ($wrap == 'none') ? "\n". $vf.$qnotesOutFmt . "\n"
          : "\n". "(:div10 id='$id' class='$class':)" .
            "\n" . $vf.$qnotesOutFmt . "\n". '(:div10end:)';

      $qnotesOutFmt = $qnotesOutFmt. "\n". "(:jscmDraw $id $orient $theme:)"; //@TODO

      }

    if(
       strtolower($qnDrawType) === 'list' &&
       strtolower(@$args['listType']) === 'phplm'
      ) {

      //============== list for Phplm (tree or menu) #@TODO
      $GLOBALS['RedoMarkupLine']++;
      foreach($c as $v) {
        list($v, $c1, $c2, $c3, $c4, $c5, $c6, $c7, $c8, $c9) = explode('#', $v);
        $tfmt = empty($c9) ? $QNotes['ListDateFmt'] : $QNotes['ListDateFmt2'];
        $c6 = $c6 ? strftime($tfmt, $c6) : ''; # modifiedOn
        $num = substr_count($v, '/');
        $v1 = ucfirst(trim(str_replace('/', '', strrchr($v, '/'))));
        eval("\$v2 = \"$fmt[$nodefmt]\";");
        $v2 = MarkupToHTML($qnpagename, $v2, array('escape' => 0));
        $v2 = Keep(preg_replace('/(\\<p\\>|\\<\\/p\\>|\\n)/s', '', "<span class='text'>".$v2."</span>"));
        $GLOBALS['RedoMarkupLine']++;
        $edl = $ScriptUrl.'?n='.$pn.'&amp;qn='.$v.'&amp;qnp='.$qnpagename;
        //[dots]|[text]|[link]|[title]|[icon]|[target]|[expanded]
        if($c1 === '1') { $linkicon = 'link_open.png'; } else { $linkicon = $c3; }
        if($v1 == '') {
          if($showrootnode) $vf = "\n" . '.|'.$qp.'|#nolink';
        } else {
          if($showrootnode) $num = $num+1;
          $num = str_repeat(".", $num);
          $o .=  "\n" . $num . '|' . $v2 . '|'. $edl . '|'. $v . '|'. $linkicon;
        }
      }
      $o = $vf . $o;
      //if(trim($o) == '') $o = '.|'.$qp.'|#nolink';
      if(trim($o) == '') return;
      //$qnotesOutFmt = $o; return;
      global $Phplm;
      $Phplm['menu']['PageNameFmt']['Text'] =  $o; unset($o);
      $qnotesOutFmt =
          //"\n". "(:phplmDraw qnotesList1 $orient $theme text type=$type:)".
          "\n". "(:phplmDraw $id $orient $theme text type=$type:)".
          "\n" . '(:phplmAllHeaderFooter:)'; //@TODO

      }


    unset($c, $out, $pageA);

